#include "gideros.h"

static int log(lua_State *L) {
    int n = lua_gettop(L);  /* number of arguments */
    int i;
    lua_getglobal(L, "tostring");
    for (i=1; i<=n; i++) {
        const char *s;
        lua_pushvalue(L, -1);  /* function to be called */
        lua_pushvalue(L, i);   /* value to print */
        lua_call(L, 1, 1);
        s = lua_tostring(L, -1);  /* get result */
        if (s == NULL)
            return luaL_error(L, LUA_QL("tostring") " must return a string to "
                              LUA_QL("print"));
        if (i>1) fputs("\t", stdout);
        fputs(s, stdout);
        lua_pop(L, 1);  /* pop result */
    }
    fputs("\n", stdout);
    return 0;
}


static void g_initializePlugin(lua_State* L)
{
    lua_pushcfunction(L, log);
    lua_setglobal(L, "log");
}

static void g_deinitializePlugin(lua_State* L)
{
    
}

REGISTER_PLUGIN("log", "1.0")
